#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   server_findLogFileInCurrentDir.py
#
#       currentDirからlogFileを探しだす。
#       timeStampは、無視する。
#
#   17/08/05    新規作成
#
#


import os
import sys
import glob
import server_findJobFiles

#
#  findLogFileInJobFile
#    jobFile内からlogFileを取得する
def getLogFileInJobFile(nameDir, jobId, jobMan):
    f = open(nameDir); lines = f.readlines(); f.close()
    caseDir = "/".join(nameDir.split("/")[:-1])
    jobFile = caseDir + "/" + lines[0].split()[0]
    logFile = server_findJobFiles.getLogFileInJobFile(jobFile, jobId, jobMan)
    return logFile

#
#  findLogFileInCaseDir
#    logFileを検索する
def findLogFileInCaseDir(caseDir, jobMan):
    files = glob.glob(caseDir + "/*")
    gFiles = []
    for nameDir in files:
        if os.path.isfile(nameDir) == True:
            gFiles.append(nameDir)
    logFile = ""
    #jobIdFileを検索
    for nameDir in gFiles:
        name = nameDir.split("/")[-1]
        if name[:len("jobId:")] == "jobId:":
            jobId = name.split(":")[-1]
            logFile = getLogFileInJobFile(nameDir, jobId, jobMan)
            break
    #solve.logを検索
    if logFile == "":
        for nameDir in gFiles:
            name = nameDir.split("/")[-1]
            if name == "solve.log":
                logFile = nameDir
                break
    #その他logFileを検索
    if logFile == "":
        for nameDir in gFiles:
            name = nameDir.split("/")[-1]
            n = name.find("o.")
            if n >= 0:
                dummyNo = name[n+2:n+5]
                try:
                    a = int(dummyNo)
                    logFile = nameDir
                except:
                    pass
                if logFile != "":
                    break
            n = name.find(".o")
            if n >= 0:
                dummyNo = name[n+2:n+5]
                try:
                    a = int(dummyNo)
                    logFile = nameDir
                except:
                    pass
                if logFile != "":
                    break
    return logFile


#メイン
if __name__ == "__main__":
    caseDir = sys.argv[1]   #currentDir
    jobMan = "#SBATCH"
    if len(sys.argv) >= 3:
        jobMan = sys.argv[2]
    #logFileを検索
    logFile = findLogFileInCaseDir(caseDir, jobMan)
    print logFile


