#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       createDexcs.py
#
#           dexcs用のtreefoam.pyとbashScriptを作成する
#
#       17/03/19    新規作成
#          03/21    bashScriptの作成も追加
#       18/01/18    addPathの内容を修正
#                   DEXCS/Swakが「~/Desktop」から「/opt」に移動された事による。
#                   （DEXCS2017より移動）
#          06/30    DEXCS/Swakの場所誤記、修正。（バグ）
#

addImport = """
#----Dexcs用追加--------------
import pyDexcsSwak
import MyDialog1
#-----------------------------
"""

addMenuID = """
#--Dexcs用追加--------------------
dexcsSwak = wx.NewId()
dexcsSwakIniID = wx.NewId()
dexcsSelectTemplateID = wx.NewId()
dexcsSelectPolyMeshID = wx.NewId()
dexcsDispBlockMeshID = wx.NewId()
dexcsRunBlockMeshID = wx.NewId()
dexcsRunCfMeshID = wx.NewId()
dexcsRunCheckMeshID = wx.NewId()
dexcsRunAllrunID = wx.NewId()
dexcsRunAllcleanID = wx.NewId()
dexcsRunSubmitJob = wx.NewId()
dexcsRunSubmitStatus = wx.NewId()
dexcsSelectSnappID = wx.NewId()
dexcsEditSnappyHexMeshID = wx.NewId()
dexcsRunSnappyHexMeshID = wx.NewId()
dexcsChangePatchNameID = wx.NewId()
dexcsSetPatchFromBoundID = wx.NewId()
dexcsPotentialFlowID = wx.NewId()
dexcsPyFoamID = wx.NewId()
dexcsPlotTimelineID = wx.NewId()
dexcsStandardLogID = wx.NewId()
dexcsJGPID = wx.NewId()
dexcsKdiff3ID = wx.NewId()
dexcsSearchID = wx.NewId()
#---------------------------------
"""

addMenu = """
        #dexcs用追加----------------------------------------
        self.menuDexcsSwak = wx.Menu()
        self.menuDexcsSwakIni = wx.MenuItem(self.menuDexcsSwak, dexcsSwakIniID, _(u"ケース初期化(計算のやり直し)"), _(u"ケースを初期化（計算のやり直し）をします"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsSwakIni)
        self.menuDexcsDispBlockMesh = wx.MenuItem(self.menuDexcsSwak, dexcsDispBlockMeshID, _(u"blockMeshの表示"), _(u"blockMeshDictを表示確認しながら編集します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsDispBlockMesh)
        self.menuDexcsRunBlockMesh = wx.MenuItem(self.menuDexcsSwak, dexcsRunBlockMeshID, _(u"blockMeshの実行"), _(u"blockMeshを実行します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunBlockMesh)
        self.menuDexcsRunCfMesh = wx.MenuItem(self.menuDexcsSwak, dexcsRunCfMeshID, _(u"cfMesh(cartesianMesh)の実行"), _(u"cfMesh(cartesianMesh)を実行します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunCfMesh)
        self.menuDexcsRunCheckMesh = wx.MenuItem(self.menuDexcsSwak, dexcsRunCheckMeshID, _(u"checkMeshの実行"), _(u"checkMeshを実行します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunCheckMesh)
        self.menuDexcsRunAllrun = wx.MenuItem(self.menuDexcsSwak, dexcsRunAllrunID, _(u"Allrunの実行"), _(u"Allrunを実行します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunAllrun)
        self.menuDexcsRunAllclean = wx.MenuItem(self.menuDexcsSwak, dexcsRunAllcleanID, _(u"Allcleanの実行"), _(u"Allcleanを実行します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunAllclean)
        self.menuDexcsRunSubmitJob = wx.MenuItem(self.menuDexcsSwak, dexcsRunSubmitJob, _(u"バッチジョブをサブミット"), _(u"バッチスクリプトを選択してサブミットします"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunSubmitJob)
        self.menuDexcsRunSubmitStatus = wx.MenuItem(self.menuDexcsSwak, dexcsRunSubmitStatus, _(u"バッチジョブの確認"), _(u"バッチジョブの状態を確認します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsRunSubmitStatus)
        self.menuDexcsStandardLog = wx.MenuItem(self.menuDexcsSwak, dexcsStandardLogID, _(u"ソルバー実行ログの解析"), _(u"ソルバー実行ログを解析します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsStandardLog)
        self.menuDexcsSwak.AppendSeparator()
        self.menuDexcsJGP = wx.MenuItem(self.menuDexcsSwak, dexcsJGPID, _(u"汎用gnuplot-GUI(jgp)の起動"), _(u"jgpを起動します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsJGP)
        self.menuDexcsKdiff3 = wx.MenuItem(self.menuDexcsSwak, dexcsKdiff3ID, _(u"ケース比較（Kdiff3）の起動"), _(u"Kdiff3を起動します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsKdiff3)
        self.menuDexcsSearch = wx.MenuItem(self.menuDexcsSwak, dexcsSearchID, _(u"十徳サーチ"), _(u"ソースコードを検索します"), wx.ITEM_NORMAL)
        self.menuDexcsSwak.AppendItem(self.menuDexcsSearch)
        self.frame_1_menubar.Append(self.menuDexcsSwak, _(u"十徳ナイフ(&D)"))
        #------------------------------------------------------------
"""

addEvent = """
        #dexcs用追加d------------------------
        self.Bind(wx.EVT_MENU, self.selDexcsSwakIni, self.menuDexcsSwakIni)
        self.Bind(wx.EVT_MENU, self.selDexcsDispBlockMesh, self.menuDexcsDispBlockMesh)
        self.Bind(wx.EVT_MENU, self.selDexcsRunBlockMesh, self.menuDexcsRunBlockMesh)
        self.Bind(wx.EVT_MENU, self.selDexcsRunCfMesh, self.menuDexcsRunCfMesh)
        self.Bind(wx.EVT_MENU, self.selDexcsRunCheckMesh, self.menuDexcsRunCheckMesh)
        self.Bind(wx.EVT_MENU, self.selDexcsRunAllrun, self.menuDexcsRunAllrun)
        self.Bind(wx.EVT_MENU, self.selDexcsRunAllclean, self.menuDexcsRunAllclean)
        self.Bind(wx.EVT_MENU, self.selDexcsRunSubmitJob, self.menuDexcsRunSubmitJob)
        self.Bind(wx.EVT_MENU, self.selDexcsRunSubmitStatus, self.menuDexcsRunSubmitStatus)
        self.Bind(wx.EVT_MENU, self.selDexcsStandardLog, self.menuDexcsStandardLog)
        self.Bind(wx.EVT_MENU, self.selDexcsJGP, self.menuDexcsJGP)
        self.Bind(wx.EVT_MENU, self.selDexcsKdiff3, self.menuDexcsKdiff3)
        self.Bind(wx.EVT_MENU, self.selDexcsSearch, self.menuDexcsSearch)
        #d----------------------------------
"""

addSwak = """
    #--Dexcs用追加a--------------------
    #---------dexcsSwak------------ by E.Mogura ------------
    def dexcsReload(self):
        self.writeStatus(u"tree data を読み込み中...")
        #currentCaseを保存
        item = self.tree_ctrl_1.GetSelection()
        selCaseDir = self.getDirectory(item)
        #再読込
        self.reloadItems()
        #caseName, solverをlabelにセット
        caseItem = self.getItem(solveCaseFix)
        self.changeSolveCase(caseItem)
        #currentCaseを設定
        self.setSelectCase(self.convDirToList(selCaseDir))
        self.clearStatus()

    def selDexcsSwakIni(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.initializeCase(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()

    def selDexcsSelectTemplate(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.selectTemplate(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()

    def selDexcsSelectPolyMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.selectPolyMesh(solveCaseFix)
        self.dexcsReload()
        event.Skip()

    def selDexcsDispBlockMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.dispBlockMesh(solveCaseFix,envOpenFOAMFix)
        event.Skip()

    def selDexcsRunBlockMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runBlockMesh(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()

    def selDexcsSelectSnapp(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.snappDictExport(solveCaseFix)
        event.Skip()

    def selDexcsEditSnappyHexMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.editSnappyHexMesh(solveCaseFix)
        event.Skip()

    def selDexcsRunSnappyHexMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runSnappyHexMesh(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
 
    def selDexcsChangePatchName(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.changePatchName(solveCaseFix)
        event.Skip()

    def selDexcsSetPatchFromBound(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.setPatchFromBound(solveCaseFix, envOpenFOAMFix)
        event.Skip()

    def selDexcsPotentialFlow(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runPotentialFlow(solveCaseFix, envOpenFOAMFix)
        event.Skip()

    def selDexcsPyFoam(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runPyFoam(solveCaseFix, envOpenFOAMFix)
        event.Skip()

    def selDexcsPlotTimeline(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runPlotTimeline(solveCaseFix)
        event.Skip()

    def selDexcsStandardLog(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runStandardLog(solveCaseFix, envOpenFOAMFix)
        event.Skip()

    def selDexcsJGP(self, event):  # wxGlade: MyFrame.<event_handler>
        os.system("java -cp /opt/jgp/classes jgp.gui.JGP &")
        event.Skip()

    def selDexcsKdiff3(self, event):  # wxGlade: MyFrame.<event_handler>
        os.system("kdiff3 &")
        event.Skip()

    def selDexcsSearch(self, event):  # wxGlade: MyFrame.<event_handler>
        global envOpenFOAMFix
        pyDexcsSwak.runSearch(envOpenFOAMFix)
        event.Skip()
    #a----------------------------------------------

    def selDexcsRunCfMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runCfMesh(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    def selDexcsRunCheckMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runCheckMesh(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    def selDexcsRunAllrun(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runAllrun(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    def selDexcsRunAllclean(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runAllclean(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    def selDexcsRunSubmitJob(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runSubmitJob(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    def selDexcsRunSubmitStatus(self, event):  # wxGlade: MyFrame.<event_handler>
        global solveCaseFix, envOpenFOAMFix
        pyDexcsSwak.runSubmitStatus(solveCaseFix, envOpenFOAMFix)
        self.dexcsReload()
        event.Skip()
    #-----------------------------------------------------------------
"""

addPath = """
export dexcsSwakPath=/opt/DEXCS/SWAK         #Dexcs
"""

def readFileLines(fileName):
    f = open(fileName)
    lines = f.readlines()
    f.close()
    return lines

def writeFileLines(fileName, lines):
    f = open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()

#
#  addDexcsImport
#    import行以外が10行続いた時、最後import行の次の行に追加する
def addDexcsImport(lines):
    ip = -1
    n = 0
    flag = 0
    for i in range(len(lines)):
        line = lines[i]
        if line[0] != "#" and len(line) >= len("import"):
            words = line.split()
            if len(words) > 1:
                if words[0] == "import" or words[0] == "from":
                    n = 0
                    ip = i
                else:
                    n += 1
            if n > 10:
                flag = 1
                break
    if flag == 0:
        print "error: importが追加できません"
    ip += 1
    addLines = addImport.split("\n")
    for i in range(len(addLines)):
        addLines[i] += "\n"
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

#
#  changeVersion
#    versionを修正
def changeVersion(lines):
    flag = 0
    for i in range(len(lines)):
        line = lines[i]
        if line[:len("version")] == "version":
            words = line.split('"')
            words[1] += "+dexcsSwak"
            lines[i] = '"'.join(words)
            flag = 1
            break
    if flag == 0:
        print "error: versionが変更できません"
    return lines

#
#  addMenuID
#    menuIDを追加
#    最後の「wx.NewId()」行の次に追加する            
def addDexcsMenuID(lines):
    ip = -1
    n = 0
    flag = 0
    error = "NG"
    for i in range(len(lines)):
        line = lines[i]
        if line.find("wx.NewId()") >= 0:
            flag = 1
            n = 0
            ip = i
        else:
            if flag == 1:
                n += 1
        if n > 10:
            error = "OK"
            break
    if error == "NG":
        print "error: menuIDが追加できません"
    ip += 1
    addLines = addMenuID.split("\n")
    for i in range(len(addLines)):
        addLines[i] += "\n"
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

#
#  addDexcsMenu
#    「_(u"ツール(&T)")」行の次に追加する
def addDexcsMenu(lines):
    flag = 0
    ip = -1
    for i in range(len(lines)):
        line = lines[i]
        if line.find('_(u"ツール(&T)")') >= 0:
            ip = i
            flag = 1
            break
    if flag == 0:
        print "error: dexcsMenuが追加できません"
    ip += 1
    addLines = addMenu.split("\n")
    for i in range(len(addLines)):
        addLines[i] += "\n"
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines    

#
#  addDexcsEvent
#    「self.Bind(wx.EVT_MENU, self.selRunSalome, self.menuRunSalome)」行の次に追加
def addDexcsEvent(lines):
    ip = -1
    flag = 0
    for i in range(len(lines)):
        line = lines[i]
        if line.find("self.Bind(wx.EVT_MENU, self.selRunSalome, self.menuRunSalome)") >= 0:
            ip = i
            flag = 1
            break
    if flag == 0:
        print "error: dexcsEventが追加できません"
    ip += 1
    addLines = addEvent.split("\n")
    for i in range(len(addLines)):
        addLines[i] += "\n"
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

#
#  addDexcsSwak
#    「end of class MyFrame」の前に追加
def addDexcsSwak(lines):
    ip = -1
    flag = 0
    for i in range(len(lines)):
        line = lines[i]
        if line.find("end of class MyFrame") >= 0:
            ip = i
            flag = 1
            break
    if flag == 0:
        print "error: dexcsSwakが追加できません"
    addLines = addSwak.split("\n")
    for i in range(len(addLines)):
        addLines[i] += "\n"
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

#
#  getTreefoamScript
#    scriptNameを取得
def getTreefoamScript(lines):
    scriptName = ""
    for line in lines:
        #「gnome-terminal」の行を検索
        if line[:len("gnome-terminal")] == "gnome-terminal":
            #起動しているscript名を取得
            scriptName = line.split()[-1]
            scriptName = scriptName.split("/")[-1]
            break
    if scriptName == "":
        print "error: 起動用スクリプト名が取得できません"
    return scriptName

#
#  addDexcsPath
#    dexcsPathを追加
def addDexcsPath(lines):
    ip = -1
    for i in range(len(lines)):
        line = lines[i]
        words = line.split()
        #「exoprt TreeFoamUserPath」行を検索
        if len(words) >= 2:
            if words[0] == "export" and words[1][:len("TreeFoamUserPath")] == "TreeFoamUserPath":
                ip = i
                break
    if ip == -1:
        print "error: dexcsPathが追加できません"
        newLines = lines
    else:
        #次の行にpathを追加
        ip += 1
        newLines = lines[:ip] + [addPath] + lines[ip:]
    return newLines

#
#  addDexcsPythonPath
#    pythonPathに「$dexcsSwakPath」を追加
def addDexcsPythonPath(lines):
    ip = -1
    for i in range(len(lines)):
        line = lines[i]
        words = line.split()
        #「export PYTHONPATH」の行を検索
        if len(words) >= 2:
            if words[0] == "export" and words[1][:len("PYTHPNPATH")] == "PYTHONPATH":
                ip = i
                break
    if ip == -1:
        print "error: PYTHONPATHが追加できません"
        newLines = lines
    else:
        #「$dexcsSwakPath」を追加
        words = lines[ip].split(":")
        newWords = words[:-1] + ["$dexcsSwakPath"] + [words[-1]]
        lines[ip] = ":".join(newWords)
    return lines


if __name__ == "__main__":
    #treefoam.pyの作成
    fileName = "treefoam.py"
    lines = readFileLines(fileName)
    lines = addDexcsImport(lines)
    lines = changeVersion(lines)
    lines = addDexcsMenuID(lines)
    lines = addDexcsMenu(lines)
    lines = addDexcsEvent(lines)
    lines = addDexcsSwak(lines)
    fileName = "dexcs_treefoam.py"
    writeFileLines(fileName, lines)
    #treefoam-XXXの作成
    fileName = "treefoam"
    lines = readFileLines(fileName)
    scriptName = getTreefoamScript(lines)
    lines = readFileLines(scriptName)
    lines = addDexcsPath(lines)
    lines = addDexcsPythonPath(lines)
    fileName = "dexcs_" + scriptName
    writeFileLines(fileName, lines)


