#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#       nagoyaFxJobControlDialog.py
#
#       名大FX100用のJob管理用
#       JobFileの選択、作成、投入。PJMコマンドは自動作成される。
#
#   17/07/22    新規作成（FOCUS用を修正）
#      07/23    制限時間、vnode数を追加
#      08/05    showLog, plotWatcher:jobを表示させていない場合、currentDirでlogFileを検索
#      08/09    setCurrDir:currDirの表示がおかしくなる事があり、修正
#      09/12    __set_properties:表示内容がおかしかったので修正。
#      09/12    cx400用をfx100用に修正
#      09/26    writeJobFile:errorCheckを修正
#
#
# generated by wxGlade 0.6.7+ on Sun Oct 23 10:54:16 2016
#

import wx
import os
import sys
import glob
import time
import subprocess
import pyTreeFoam
import getFoamContents
import getOpenFileDDialog


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade

serverName = ""
caseDir = ""
jobFile = ""
queue = ""
nCpu = ""
nNode = ""
queueNames = []         #queue名のlist


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"名大cx100 Job管理"))
        self.label_16 = wx.StaticText(self, wx.ID_ANY, _("currDir:"))
        self.label_17 = wx.StaticText(self, wx.ID_ANY, _("label_17"))
        self.label_13 = wx.StaticText(self, wx.ID_ANY, _(u"Jobファイルを選択、作成して、Jobを投入する。\npjsubオプション（キュー名、プロセス数等）は、右画面上で、再設定できる。"))
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"Job File名"))
        self.text_ctrl_4 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"Job編集"))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY, style=wx.LI_VERTICAL)
        self.panel_3 = wx.Panel(self, wx.ID_ANY)
        self.label_5 = wx.StaticText(self.panel_3, wx.ID_ANY, _(u"キュー:"))
        self.combo_box_1 = wx.ComboBox(self.panel_3, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_12 = wx.StaticText(self.panel_3, wx.ID_ANY, _(u"制限時間:"))
        self.text_ctrl_5 = wx.TextCtrl(self.panel_3, wx.ID_ANY, "")
        self.label_18 = wx.StaticText(self.panel_3, wx.ID_ANY, _("hrs"))
        self.panel_1 = wx.Panel(self, wx.ID_ANY)
        self.label_11 = wx.StaticText(self.panel_1, wx.ID_ANY, _(u"core数/vnode:"))
        self.text_ctrl_1 = wx.TextCtrl(self.panel_1, wx.ID_ANY, "")
        self.label_19 = wx.StaticText(self, wx.ID_ANY, _(u"vnode数:"))
        self.text_ctrl_6 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"設定file編集"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"設定"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"Job投入実行..."))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"ノードの状況確認"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _("pjstat"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _("--rsc"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _("--limit"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"その他コマンド"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_13 = wx.Button(self, wx.ID_ANY, _("run"))
        self.text_ctrl_3 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.sizer_3_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job投入"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, "")
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"投入Job読込・表示"))
        self.button_14 = wx.Button(self, wx.ID_ANY, _("pjstat"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"Jobを選択後、クリック"))
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"log表示"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _("tail -f"))
        self.label_15 = wx.StaticText(self, wx.ID_ANY, _(u" 残渣の表示"))
        self.button_16 = wx.Button(self, wx.ID_ANY, _("plotWatcher"))
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"Job停止"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _("pjdel"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _("label_2"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job実行状況の確認"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"folder開く"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"login端末起動"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onSelectJob, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditJob, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onEditSettingFile, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onSetQueueCpu, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunJob, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onPjstat, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRsc, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onLimit, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onRunCommand, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onPjstatList, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onShowLog, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onPlotWatcher, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onPjdel, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTerminal, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_1)
        # end wxGlade

        self.Bind(wx.EVT_TEXT, self.onSetJobFile, self.text_ctrl_4)
        self.text_ctrl_2.Bind(wx.EVT_KEY_DOWN, self.onKey)
        self.setComboBox()
        self.hideSbatchOption()
        #self.setPjstatLabe()
        self.setCurrDir()

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.text_ctrl_4.SetMinSize((150, 28))
        self.button_5.SetMinSize((50, 30))
        self.combo_box_1.SetMinSize((138, 30))
        self.text_ctrl_5.SetMinSize((50, 28))
        self.panel_3.SetMinSize((340, 30))
        self.text_ctrl_1.SetMinSize((70, 28))
        self.panel_1.SetMinSize((190, 30))
        self.text_ctrl_6.SetMinSize((70, 28))
        self.button_8.SetMinSize((110, 60))
        self.button_9.SetMinSize((110, 40))
        self.text_ctrl_2.SetMinSize((120, 28))
        self.button_13.SetMinSize((50, 30))
        self.text_ctrl_3.SetMinSize((520, 130))
        # end wxGlade

        self.SetTitle(_(u"名大FX100 Job管理"))
        self.label_1.SetLabel(_(u"名大FX100 Job管理"))
        self.label_11.SetLabel(_(u"プロセス数"))
        self.label_19.SetLabel(_(u"ノード数"))

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_26 = wx.BoxSizer(wx.VERTICAL)
        sizer_30 = wx.BoxSizer(wx.VERTICAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.VERTICAL)
        sizer_36 = wx.BoxSizer(wx.VERTICAL)
        sizer_35 = wx.BoxSizer(wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_25 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_22 = wx.BoxSizer(wx.VERTICAL)
        sizer_23 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_45 = wx.BoxSizer(wx.VERTICAL)
        sizer_46 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_39 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_40 = wx.BoxSizer(wx.VERTICAL)
        sizer_41 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_31 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_32 = wx.BoxSizer(wx.VERTICAL)
        sizer_33 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_37 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_37.Add(self.label_16, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_37.Add(self.label_17, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(sizer_37, 0, wx.EXPAND, 0)
        sizer_3.Add(self.label_13, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_10.Add(self.label_10, 0, wx.LEFT, 5)
        sizer_33.Add(self.text_ctrl_4, 0, wx.LEFT, 5)
        sizer_33.Add(self.button_5, 0, 0, 0)
        sizer_32.Add(sizer_33, 0, wx.EXPAND, 0)
        sizer_31.Add(sizer_32, 1, wx.EXPAND, 0)
        sizer_10.Add(sizer_31, 0, wx.EXPAND, 0)
        sizer_10.Add(self.button_6, 0, wx.LEFT, 5)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_9.Add(self.static_line_2, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_41.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_40.Add(sizer_41, 1, wx.ALIGN_RIGHT, 0)
        sizer_39.Add(sizer_40, 1, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        sizer_39.Add(self.combo_box_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_39.Add(self.label_12, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_39.Add(self.text_ctrl_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_39.Add(self.label_18, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        self.panel_3.SetSizer(sizer_39)
        sizer_14.Add(self.panel_3, 1, wx.EXPAND, 0)
        sizer_46.Add(self.label_11, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_45.Add(sizer_46, 1, wx.ALIGN_RIGHT, 0)
        sizer_42.Add(sizer_45, 1, wx.EXPAND, 0)
        sizer_42.Add(self.text_ctrl_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        self.panel_1.SetSizer(sizer_42)
        sizer_15.Add(self.panel_1, 1, wx.ALIGN_RIGHT, 0)
        sizer_15.Add(self.label_19, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_15.Add(self.text_ctrl_6, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_14.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_16.Add(self.button_7, 0, wx.LEFT, 45)
        sizer_14.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_13.Add(sizer_14, 0, wx.LEFT | wx.EXPAND, 0)
        sizer_17.Add(self.button_8, 0, 0, 0)
        sizer_17.Add(self.button_9, 0, 0, 0)
        sizer_13.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_13, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_3.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_3.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_20.Add(self.label_6, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_10, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_11, 0, 0, 0)
        sizer_21.Add(self.button_12, 0, 0, 0)
        sizer_20.Add(sizer_21, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_22.Add(self.label_7, 0, 0, 0)
        sizer_23.Add(self.text_ctrl_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_23.Add(self.button_13, 0, 0, 0)
        sizer_22.Add(sizer_23, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_22, 0, wx.LEFT | wx.EXPAND, 10)
        sizer_18.Add(sizer_19, 0, wx.EXPAND, 0)
        sizer_11.Add(self.text_ctrl_3, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 0)
        sizer_25.Add(sizer_11, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_24.Add(sizer_25, 1, wx.EXPAND, 0)
        sizer_18.Add(sizer_24, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_18, 1, wx.TOP | wx.EXPAND, 5)
        sizer_2.Add(sizer_3, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_28.Add(self.label_3, 0, 0, 0)
        sizer_28.Add(self.label_8, 0, 0, 0)
        sizer_28.Add(self.button_14, 0, 0, 0)
        sizer_27.Add(sizer_28, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_29.Add(self.label_4, 0, wx.LEFT, 20)
        sizer_35.Add(self.label_14, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_35.Add(self.button_4, 0, 0, 0)
        sizer_12.Add(sizer_35, 0, wx.EXPAND, 0)
        sizer_36.Add(self.label_15, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_36.Add(self.button_16, 0, 0, 0)
        sizer_12.Add(sizer_36, 0, wx.EXPAND, 0)
        sizer_34.Add(self.label_9, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_34.Add(self.button_15, 0, 0, 0)
        sizer_12.Add(sizer_34, 1, wx.LEFT | wx.EXPAND, 20)
        sizer_29.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_27.Add(sizer_29, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_26.Add(sizer_27, 0, wx.EXPAND, 0)
        sizer_30.Add(self.label_2, 0, wx.LEFT, 5)
        sizer_30.Add(self.list_box_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_26.Add(sizer_30, 1, wx.EXPAND, 0)
        sizer_4.Add(sizer_26, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_8.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_8.Add(self.button_3, 0, 0, 0)
        sizer_7.Add(sizer_8, 1, wx.TOP | wx.BOTTOM | wx.EXPAND, 10)
        sizer_5.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_6.Add(self.button_1, 0, wx.RIGHT | wx.TOP | wx.ALIGN_RIGHT, 10)
        sizer_5.Add(sizer_6, 1, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

        self.setPjstatLabe()
        sizer_1.Fit(self)
        self.Layout()


    #参照...（job選択）
    def onSelectJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectJob()

    #Job編集
    def onEditJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editJob()

    #設定file編集
    def onEditSettingFile(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSettingFile()

    #設定
    def onSetQueueCpu(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setQueueCpu()

    #job投入実行
    def onRunJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runJob()

    #pjstat
    def onPjstat(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pjstat()

    #pjstat_rsc
    def onRsc(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pjstat_rsc()

    #pjstat_limit
    def onLimit(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pjstat_limit()

    #その他コマンド実行
    def onRunCommand(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runCommand()

    #pjstat（実行状況のリスト）
    def onPjstatList(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pjstatList()

    #log表示（tail-f）
    def onShowLog(self, event):  # wxGlade: MyFrame.<event_handler>
        self.showLog()

    #残渣の表示（plotWatcher）
    def onPlotWatcher(self, event):  # wxGlade: MyFrame.<event_handler>
        self.plotWatcher()

    #pjdel（jobの停止
    def onPjdel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pjdel()

    #folder開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFolder()

    #login端末を開く
    def onRunTerminal(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTerminal()

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #jobFile入力
    def onSetJobFile(self, event):
        self.showSbatchOption()

    #コマンドのkey入力
    def onKey(self, event):
        key = event.GetKeyCode()
        if key == 13:
            self.onRunCommand(event)
        event.Skip()

# end of class MyFrame

    #
    #  setCurrDir
    #    caseDirをlabelにセット
    def setCurrDir(self):
        currDir = caseDir
        maxChara = 55
        if len(currDir) > maxChara:
            l = len(currDir) - (maxChara - 3)
            currDir = "..." + currDir[l:]
        self.label_17.SetLabel(currDir)

    #
    #  setComboBox
    #    comboBoxにデータセット
    def setComboBox(self):
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(queueNames)

    #
    #  setPjstatLabe
    #    squeue実行時のtitle行を設定
    def setPjstatLabe(self):
        titleLine = " JOB_ID     JOB_NAME   MD ST  USER     START_DATE      ELAPSE_LIM NODE_REQUIRE    VNODE  CORE V_MEM        "
        self.label_2.SetLabel(titleLine)

    #
    #  selectJob
    #    jobファイルの選択
    def selectJob(self):
        global jobFile, queue, nCpu, nNode
        title = _(u"Jobファイルの選択")
        mess = _(u"編集するJobファイルを選択する。")
        fileFilter = "*"
        [stat, fileName] = getOpenFileDDialog.Show(title, mess, caseDir, fileFilter)
        if stat == "OK":
            jobFile = fileName
            self.text_ctrl_4.SetValue(jobFile)
            [queue, nCpu, nNode, hours] = readJobFile(fileName)
            self.setSbatchOption(queue, nCpu, nNode, hours)

    #
    #  editJob
    #    jobFileの編集
    def editJob(self):
        jobName = self.text_ctrl_4.GetValue()
        fileName = caseDir + "/" + jobName
        pyTreeFoam.runEditor(fileName)

    #
    #  editSettingFile
    #    focus設定file編集
    def editSettingFile(self):
        global queueNames
        path = os.getenv("TreeFoamUserPath") + "/data"
        fileName = path + "/nagoyaFx_data"
        pyTreeFoam.runEditorWait(fileName)
        [data, logFiles] = readFxData()
        queueNames = data
        selQueue = self.combo_box_1.GetStringSelection()
        self.setComboBox()
        self.combo_box_1.SetStringSelection(selQueue)

    #
    #  setQueueCpu
    #    sbatchのoptionを書き込み
    def setQueueCpu(self):
        jobFile = self.text_ctrl_4.GetValue()
        job = jobFile
        queue = self.combo_box_1.GetStringSelection()
        nCpu = self.text_ctrl_1.GetValue()
        hours = self.text_ctrl_5.GetValue()
        nNode = self.text_ctrl_6.GetValue()
        oFile = getFocusOutputLogFileNames(job)
        error = writeJobFile(jobFile, job, queue, nCpu, nNode, hours, oFile)
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return
        hms = getHMSfromHours(hours)
        title = _(u"Jobファイルの修正")
        mess = _(u"以下の内容を書き込みました。\n")
        mess += ("  #PJM -N " + job + "\n")
        mess += ('  #PJM -L "rscgrp=' + queue + '"\n')
        mess += ('  #PJM -L "node=' + nNode + '"\n')
        mess += ('  #PJM --mpi "proc=' + nCpu + '"\n')
        mess += ('  #PJM -L "elapse=' + hms + '"\n')
        mess += ("  #PJM -o " + oFile + "\n")
        self.okDialog(title, mess)

    #
    #  runJob
    #    job投入・実行
    def runJob(self):
        jobFile = self.text_ctrl_4.GetValue()
        [queue, nCpu, nNode, hours] = readJobFile(jobFile)
        error = ""
        if queue == "":
            error = _(u"キューが設定されていません。")
        elif nCpu == "":
            error = _(u"nPs（プロセス数）が設定されていません。")
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return

        title = _(u"Jobの投入")
        mess = _(u"以下の条件でJobを投入します。\n")
        mess += _(u"  キュー名: ") + queue + "\n"
        mess += _(u"  proc数: 　") + nCpu + "\n"
        mess += _(u"  node数:   ") + nNode + "\n"
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            #hostデータ読み込み
            data = pyTreeFoam.readSshfsData(serverName)
            hostDir = data[2]
            mountPoint = data[3]
            login = data[4]
            setEnviron = data[5]
            #setEnvironを再セット
            workDir = hostDir + caseDir[len(mountPoint):]
            lines = setEnviron.split("\n")
            i = len(lines) - 1
            while i >= 0:
                if lines[i][:len("cd ")] == "cd ":
                    words = lines[i].split()
                    lines[i] = "cd " + workDir
                    break
                i -= 1
            setEnviron = "\n".join(lines)
            fileName = os.getenv("TreeFoamUserPath") + "/temp/setEnviron"
            f=open(fileName, "w"); f.write(setEnviron); f.close()
            pyTreeFoam.scpCommandNoTerm(fileName, "~", serverName)
            #実行
            comm = "pjsub " + jobFile
            cont = runServerCommandReturnCont(workDir, comm)
            #旧のjobIdファイルを削除
            jobIdFiles = glob.glob(caseDir + "/jobId:*")
            comm = "rm -rf " + caseDir + "/jobId:*"
            os.system(comm)
            #新しいjobId取得、jobIdファイル作成
            words = cont.split()
            jobId = "jobId:" + words[-2]
            fileName = caseDir + "/" + jobId
            f=open(fileName, "w"); f.write(jobFile); f.close()
            #実行の状況を表示
            title = _(u"Jobの投入")
            mess = _(u"Jobを投入しました。") + "\n\n"
            mess += cont.decode("utf-8")
            self.okDialog(title, mess)

    #
    #  pjstat
    #    pjstatコマンド実行
    def pjstat(self):
        comm = "pjstat"
        cont = runServerCommandReturnCont("~", comm)
        self.text_ctrl_3.SetValue(cont)

    #
    #  pjstat_rsc
    #    pjstat --rscコマンド実行
    def pjstat_rsc(self):
        comm = "pjstat --rsc"
        cont = runServerCommandReturnCont("~", comm)
        self.text_ctrl_3.SetValue(cont)

    #
    #  pjstat_limit
    #    pjstat　--limitコマンド実行
    def pjstat_limit(self):
        comm = "pjstat --limit"
        cont = runServerCommandReturnCont("~", comm)
        self.text_ctrl_3.SetValue(cont)

    #
    #  runCommand
    #    その他コマンド実行
    def runCommand(self):
        data = pyTreeFoam.readSshfsData(serverName)
        hostDir = data[2]
        mountPoint = data[3]
        login = data[4]
        #実行
        workDir = hostDir + caseDir[len(mountPoint):]
        comm = self.text_ctrl_2.GetValue()
        cont = runServerCommandReturnCont(workDir, comm)
        #実行状況を表示
        self.text_ctrl_3.SetValue(cont)

    #
    #  pjstatList
    #    pjstatコマンド実行し、実行状況のリストを取得
    def pjstatList(self):
        comm = "pjstat"
        cont = runServerCommandReturnCont("~", comm)
        lines = cont.split("\n")[:-1]
        items = []; flag = 0
        for line in lines:
            if line[:len("JOB_ID ")] == "JOB_ID ":
                flag = 1
            elif flag == 1:
                items.append(line)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(items)

    #
    #  showLog
    #    選択されたJobのlogを表示（tail-f）
    def showLog(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            #itemを選択していない場合
            n = self.list_box_1.GetCount()
            if n == 0:
                #listBox内が空の場合
                title = _(u"log表示")
                mess = _(u"currentDirectoryのlogを表示します。")
                stat = self.okCancelDialog(title, mess)
                if stat != "OK":
                    return
                #currentDir内でlogFileを検索
                logFile = getLogFileInCurrentDir()
                if logFile == "":
                    title = _(u"エラー")
                    mess = _(u"logFileが検出できませんでした。")
                    self.errDialog(title, mess)
                    return
            else:
                #listBox内にjobが表示されている状態でjobを選択していない場合
                title = _(u"エラー")
                mess = _(u"jobが選択されていません。")
                self.errDialog(title, mess)
                return
        else:
            jobId = item.split()[0]
            logFile = getLogFile(jobId)
            if logFile == "":
                title = _(u"エラー")
                mess = _(u"logFileが検出できませんでした。")
                self.errDialog(title, mess)
                return

        #setEnvironを作成
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        openDir = "/".join(logFile.split("/")[:-1])
        lines = setEnviron.split("\n")
        i = len(lines) - 1
        while i >= 0:
            if lines[i][:len("cd")] == "cd":
                words = lines[i].split()
                lines[i] = "cd " + openDir
                break
            i -= 1
        setEnviron = "\n".join(lines)
        #tmpFileを作成
        newSetEnviron = setEnviron + "tail -n 200 -f " + logFile + "\n"
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(newSetEnviron); f.close()
        #envファイルを転送
        pyTreeFoam.scpCommandNoTerm(fileName, "~", serverName)
        #login端末を起動
        pyTreeFoam.runLoginTerm(foamTermSize, serverName)

    #
    #  plotWatcher
    #    plotWatcherを起動
    def plotWatcher(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            #itemを選択していない場合
            n = self.list_box_1.GetCount()
            if n == 0:
                #listBox内が空の場合
                title = _(u"log表示")
                mess = _(u"currentDirectoryの残渣を表示します。")
                stat = self.okCancelDialog(title, mess)
                if stat != "OK":
                    return
                #currentDir内でlogFileを検索
                logFile = getLogFileInCurrentDir()
                if logFile == "":
                    title = _(u"エラー")
                    mess = _(u"logFileが検出できませんでした。")
                    self.errDialog(title, mess)
                    return
            else:
                title = _(u"エラー")
                mess = _(u"jobが選択されていません。")
                self.errDialog(title, mess)
                return
        else:
            jobId = item.split()[0]
            logFile = getLogFile(jobId)
            if logFile == "":
                title = _(u"エラー")
                mess = _(u"logFileが検出できませんでした。")
                self.errDialog(title, mess)
                return

        #logFileをlocal側のpathに変換
        logFile = changeLocalPath(logFile)
        if logFile == "":
            title = _(u"エラー")
            mess = _(u"logFileが検出できません。") + "\n"
            return
        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        #logFile = mountDir + logFile[len(hostDir):]
        #OpenFOAMの環境設定fileを取得
        configData = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAMFix = configData[1]
        #caseDirを取得
        solveCase = "/".join(logFile.split("/")[:-1])
        #起動スクリプト作成
        cont = "#!/ban/bash\n"
        cont = cont + ". " + envOpenFOAMFix + "\n"
        cont = cont + 'echo -n "running plotWatcher"\n'
        cont = cont + "pyFoamPlotWatcher.py " + logFile + " 1> /dev/null 2> /dev/null\n"
        plotWatcher = solveCase + "/plotWatcher"
        f = open(plotWatcher, "w")
        f.write(cont)
        f.close()
        #plotWatcher実行
        os.system("chmod a+x " + plotWatcher)
        title = solveCase
        if len(title) > 30:
            title = "_..." + title[-30:]
        title = "plotWatcher:" + title
        comm = "gnome-terminal --name=" + title + " --geometry=80x2 --hide-menubar -x bash --rcfile " + plotWatcher
        os.system(comm)

    #
    #  pjdel
    #    jobの停止
    def pjdel(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"停止させるjobが選択されていません。")
            self.errDialog(title, mess)
            return

        title = _(u"jobの停止")
        mess = _(u"選択しているJobを停止させますか？")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        jobId = item.split()[0]
        comm = "pjdel " + jobId
        cont = runServerCommandReturnCont("~", comm)
        title = _(u"jobの停止")
        mess = _(u"以下のjobIdに対し、停止コマンド（pjdel）を送出しました。") + "\n\n"
        mess += "jobId: " + jobId
        self.okDialog(title, mess)

    #
    #  openFolder
    #    folderを開く
    def openFolder(self):
        pyTreeFoam.openFolderNautilus(caseDir)

    #
    #  runTerminal
    #    login端末を開く
    def runTerminal(self):
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData(serverName)
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        if mountDir == "":
            setEnviron = ""
        else:
            if mountDir == caseDir[:len(mountDir)]:
                openDir = hostDir + caseDir[len(mountDir):]
                lines = setEnviron.split("\n")
                i = len(lines) - 1
                while i >= 0:
                    if lines[i][:len("cd")] == "cd":
                        words = lines[i].split()
                        lines[i] = "cd " + openDir
                        break
                    i -= 1
                setEnviron = "\n".join(lines)
            else:
                setEnviron = ""
        #tempFileを作成
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(setEnviron); f.close()
        #envファイルを転送
        pyTreeFoam.scpCommandNoTerm(fileName, "~", serverName)
        pyTreeFoam.runLoginTerm(foamTermSize, serverName)

    #
    #  setSbatchOption
    #    sbatchのoptionをtextBoxに設定
    def setSbatchOption(self, queue, nCpu, nNode, hours):
        self.combo_box_1.SetStringSelection(queue)
        self.text_ctrl_1.SetValue(nCpu)
        self.text_ctrl_5.SetValue(hours)
        self.text_ctrl_6.SetValue(nNode)

    #
    #  hideSbatchOption
    #    sbatchオプション関連を隠す
    def hideSbatchOption(self):
        self.combo_box_1.Enable(False)
        self.text_ctrl_1.Enable(False)
        self.text_ctrl_5.Enable(False)
        self.text_ctrl_6.Enable(False)
        self.button_7.Enable(False)
        self.button_8.Enable(False)
        self.button_9.Enable(False)

    #
    #  showSbatchOption
    #    sbatchオプション関連を表示する
    def showSbatchOption(self):
        self.combo_box_1.Enable(True)
        self.text_ctrl_1.Enable(True)
        self.text_ctrl_5.Enable(True)
        self.text_ctrl_6.Enable(True)
        self.button_7.Enable(True)
        self.button_8.Enable(True)
        self.button_9.Enable(True)



    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  initialize
#
def initialize():
    global caseDir, queueNames
    [conts, logFiles] = readFxData()
    queueNames = conts

#
#  deleteComment
#    コメント文を削除
def deleteComment(lines):
    newLines = []
    for line in lines:
        n = line.find("#")
        if n >= 0:
            newLine = line[:n] + "\n"
        else:
            newLine= line
        newLines.append(newLine)
    return newLines

#
#  getFocusOutputLogFileNames
#    logFile名を取得
def getFocusOutputLogFileNames(job):
    treeFoamUserPath = os.getenv("TreeFoamUserPath")
    fileName = treeFoamUserPath + "/data/nagoyaCx_data"
    [data, logFiles] = readFxData()
    logFile = logFiles[0]
    #logFile = getStringNameFromEnv(logFile, job)
    #errLogFile = getStringNameFromEnv(errLogFile, job)
    return logFile

#
#  getStringNameFromEnv
#    環境変数を文字列に変換
def getStringNameFromEnv(name, job):

    def getEnvName(name, j):
        if name[j] == "{":
            n = name[j:].find("}")
            if n >= 0:
                jj = j + n
                strName = name[j+1:jj]
            else:
                strName = name[j+1:]
                jj = len(name)
        else:
            strName = name[j:]
            jj = len(name)
        return [strName, jj]

    newName = ""
    i = 0
    while i < len(name):
        chara = name[i]
        if chara == "$":
            [envName, i] = getEnvName(name, i+1)
            if envName == "jobName":
                strName = job
            else:
                strName = os.getenv(envName)
                if strName == None:
                    strName = ""
            newName += strName
        else:
            newName += chara
        i += 1
    return newName

#
#  readFxData
#    Fx100の設定データの読み込み
def readFxData():
    treeFoamUserPath = os.getenv("TreeFoamUserPath")
    fileName = treeFoamUserPath + "/data/nagoyaFx_data"
    if len(glob.glob(fileName)) == 0:
        treeFoamPath = os.getenv("TreeFoamPath")
        orgName = treeFoamPath + "/data/nagoyaFx_data"
        comm = "cp " + orgName + " " + treeFoamUserPath + "/data"
        os.system(comm)
    f = open(fileName); lines = f.readlines(); f.close()
    lines = deleteComment(lines)
    flag = 0; logFlag = 0
    queueNames = []; logFile = "solve.log"
    for line in lines:
        if line[0] != " ":
            words = line.split()
            if len(words) > 0:
                if words[0] == "queueNames":
                    flag = 1
                elif words[0] == "logFileName":
                    flag = 0
                    if len(words) >= 2:
                        logFile = words[1]
                        logFlag = 1
                else:
                    flag = 0
        else:
            if flag == 1:
                words = line.split()
                if len(words) > 0:
                    queueNames.append(words[0])
    queueNames.sort()
    logFiles = [logFile]
    if logFlag == 1:
        return [queueNames, logFiles]

    #fileを読み込み再作成する
    f = open(fileName); lines = f.readlines(); f.close()
    if logFlag == 0:
        #logFile errLogFile共、再作成
        addLines = ["#  Log file names\n"]
        addLines += ["#    These names are able to change at following lines.\n"]
        addLines += ["logFileName     " + logFile + "\n"]
        lines += addLines
    #書き込み
    f = open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()
    #戻る
    return [queueNames, logFiles]

#
#  readJobFile
#    jobFileの読み込み
def readJobFile(jobName):
    fileName = caseDir + "/" + jobName
    f = open(fileName); lines = f.readlines(); f.close()
    queue = ""; nCpu = ""; nNode = ""
    for line in lines:
        if line[:len("#PJM ")].upper() == "#PJM ":
            words = line.split()
            if len(words) >= 3:
                if words[1] == "--mpi" and words[2][:len('"proc=')] == '"proc=':
                    word = words[2].split("=")[-1]
                    nCpu = word[:-1]
                elif words[1] == "-L" and words[2][:len('"rscgrp=')] == '"rscgrp=':
                    word = words[2].split("=")[-1]
                    queue = word[:-1]
                elif words[1] == "-L" and words[2][:len('"node=')] == '"node=':
                    word = words[2].split("=")[-1]
                    nNode = word[:-1]
                elif words[1] == "-L" and words[2][:len('"elapse=')] == '"elapse=':
                    word = words[2].split("=")[-1]
                    elapse = word[:-1]
                    hours = getHours(elapse)
    return [queue, nCpu, nNode, hours]

#  getHours
#    000:00:00をhoursに変換
def getHours(elapse):
    hours = ""
    words = elapse.split(":")
    if len(words) == 3:
        h = float(words[0])
        m = float(words[1])
        s = float(words[2])
        hours = str(h + m/60.0 + s/3600.0)
    elif len(words) == 2:
        h = 0.0
        m = float(words[0])
        s = float(words[1])
        hs = (int((h + m/60.0 + s/3600.0) * 100 )) / 100.0
        hours = str(hs)
    return hours

#
#  writeJobFile
#    jobFileに書き込む
def writeJobFile(jobFile, job, queue, nCpu, nNode, hours, oFile):
    error = ""
    #errorチェック
    if job == "":
        error = _(u"Jobファイル名が設定されていません。")
        return error

    if queue == "" or nCpu == "":
        error = _(u"queue, nPsが入力されていません。")
        return error

    if nNode == "" or hours == "":
        error = _(u"制限時間、ノード数が入力されていません。")
        return error

    jobFile = caseDir + "/" + jobFile
    #ファイルが存在しない場合、作成する
    if len(glob.glob(jobFile)) == 0:
        f=open(jobFile, "w"); f.write("#!/bin/bash\n"); f.close()
    #ファイルを読み込む
    f = open(jobFile); lines = f.readlines(); f.close()
    #関係する行を削除
    newLines = []
    for line in lines:
        if line[:len("#PJM ")].upper() == "#PJM ":
            words = line.split()
            if not ((words[1] == "-N")
                 or (words[1] == "-L" and words[2].find('"rscgrp=') >= 0)
                 or (words[1] == "-L" and words[2].find('"vnode=') >= 0)
                 or (words[1] == "-L" and words[2].find('"node=') >= 0)
                 or (words[1] == "-L" and words[2].find('"vnode-core=') >= 0)
                 or (words[1] == "-L" and words[2].find('"elapse=') >= 0)
                 or (words[1] == "--mpi") 
                 or (words[1] == "-o" )):
                newLines.append(line)
        else:
            newLines.append(line)
    #追加する行を作成
    addLines = ["#PJM -N " + job + "\n"]
    addLines += ['#PJM -L "rscgrp=' + queue + '"\n']
    addLines += ['#PJM -L "node=' + nNode + '"\n']
    addLines += ['#PJM --mpi "proc=' + nCpu + '"\n']
    hms = getHMSfromHours(hours)
    addLines += ['#PJM -L "elapse=' + hms + '"\n']
    addLines += ["#PJM -o " + oFile + "\n"]
    #行を追加
    newLines = newLines[:1] + addLines + newLines[1:]
    #書き込み
    f = open(jobFile, "w")
    for line in newLines:
        f.write(line)
    f.close()
    return error

#
#  getHMSfromHours
#    hoursを0000:00:00形式に変換
def getHMSfromHours(hours):
    hs = float(hours)
    h = int(hs)
    m = int((hs - h) * 60.0)
    s = int((hs * 3600) - (h * 3600 + m * 60))
    hms = ":".join([str(h), str(m), str(s)])
    return hms

#
#  runServerCommandReturnCont
#    FOCUSコマンドを実行し、その結果を返す
def runServerCommandReturnCont(workDir, comm):
    data = pyTreeFoam.readSshfsData(serverName)
    login = data[4]
    sshHeader = data[6]
    #コマンド作成
    hostName = login.split()[1]
    readFile = os.getenv("TreeFoamUserPath") + "/temp/output"
    cont = "cd " + workDir + "; "
    cont += comm
    #コマンド実行
    commLine = login + ' "' + cont + '"'
    print commLine
    commLine = sshHeader + commLine       #sshHeader追加
    result = runShellCommand(commLine)
    return result

#
#  changeLocalPath
#    server側のpathをlocal側のpathに変換
def changeLocalPath(serverPath):
    [allServer, mntNames] = pyTreeFoam.getAllServerNames()
    flag = 0; localPath = ""
    for mntName in mntNames:
        data = pyTreeFoam.readSshfsData(mntName)
        hostDir = data[2]
        mountDir = data[3]
        if serverPath[:len(hostDir)+1] == hostDir+"/":
            localPath = mountDir + serverPath[len(hostDir):]
            flag = 1
            break
    return localPath

#
#  getLogFile
#    logFileを探す
def getLogFile(jobId):
    data = pyTreeFoam.readSshfsData(serverName)
    hostDir = data[2]
    mountPoint = data[3]
    #jobIdのファイルを検索
    if type(jobId) == unicode:
        jobId = jobId.encode("utf-8")
    serverDir = hostDir + "/." + caseDir[len(mountPoint):]
    comm = "python ~/TreeFoamServer/bin/server_findJobFiles.py " + jobId + " " + serverDir
    comm += " #PJM"
    resultFile = "output"
    stat = pyTreeFoam.getTreeFoamServerResult(serverName, comm, resultFile)
    if stat != "OK":
        return ""

    #検索結果を取得
    fileName = os.getenv("TreeFoamUserPath") + "/temp/" + resultFile
    f=open(fileName); lines=f.readlines(); f.close()
    logFile = lines[0]
    return logFile

#
#  getLogFileInCurrentDir
#    currentDir内でlogFileを探す
def getLogFileInCurrentDir():
    data = pyTreeFoam.readSshfsData(serverName)
    hostDir = data[2]
    mountPoint = data[3]
    #jobIdのファイルを検索
    serverDir = hostDir + "/." + caseDir[len(mountPoint):]
    comm = "python ~/TreeFoamServer/bin/server_findLogFileInCurrentDir.py " + serverDir + " #PJM"
    resultFile = "output"
    stat = pyTreeFoam.getTreeFoamServerResult(serverName, comm, resultFile)
    if stat != "OK":
        return ""

    #検索結果を取得
    fileName = os.getenv("TreeFoamUserPath") + "/temp/" + resultFile
    f=open(fileName); lines=f.readlines(); f.close()
    logFile = lines[0]
    return logFile

#
#  runShellCommand
#    command実行
def runShellCommand(comm):
    result = ""
    try:
        result += subprocess.check_output(comm, stderr=subprocess.STDOUT, shell=True)
    except subprocess.CalledProcessError as e:
        result += e.output
    return result    

if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    serverName = pyTreeFoam.getServerName(caseDir)
    initialize()
    #app = wx.PySimpleApp(0)
    #wx.InitAllImageHandlers()
    app = wx.App(0)
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
